import * as mc from '@minecraft/server';
import * as mcui from '@minecraft/server-ui';

mc.system.afterEvents.scriptEventReceive.subscribe(async data => {
  if (data.id === "rc:block_placer") {
    let block = data.sourceBlock
    let outputPosition = data.message
    let loc = block.location
    let upLocation = { x: loc.x, y: loc.y + 1, z: loc.z }
    let downLocation = { x: loc.x, y: loc.y - 1, z: loc.z }
    let northLocation = { x: loc.x, y: loc.y, z: loc.z - 1 }
    let southLocation = { x: loc.x, y: loc.y, z: loc.z + 1 }
    let eastLocation = { x: loc.x + 1, y: loc.y, z: loc.z }
    let westLocation = { x: loc.x - 1, y: loc.y, z: loc.z }
    let containerBlock = block.dimension.getBlock(upLocation)
    let northBlock = block.dimension.getBlock(northLocation)
    let southBlock = block.dimension.getBlock(southLocation)
    let eastBlock = block.dimension.getBlock(eastLocation)
    let westBlock = block.dimension.getBlock(westLocation)
    let upBlock = block.dimension.getBlock(upLocation)
    let downBlock = block.dimension.getBlock(downLocation)
    if (
      block.permutation.getState("rc:on") == 1 &&
      (!northBlock.getRedstonePower() > 0 || northBlock == undefined) &&
      (!southBlock.getRedstonePower() > 0 || southBlock == undefined) &&
      (!eastBlock.getRedstonePower() > 0 || eastBlock == undefined) &&
      (!westBlock.getRedstonePower() > 0 || westBlock == undefined) &&
      (!upBlock.getRedstonePower() > 0 || upBlock == undefined) &&
      (!downBlock.getRedstonePower() > 0 || downBlock == undefined)
    ) {
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:block_placer ["rc:lado" = ${block.permutation.getState("rc:lado")} , "rc:on" = 0]`);
    }

    mc.world.getDimension("overworld").runCommandAsync(`setblock 0 -63 0 ${block}`)

    if (
      block.permutation.getState("rc:on") == 0 &&
      ((northBlock.type != undefined && northBlock.getRedstonePower() > 0) ||
        (southBlock.type != undefined && southBlock.getRedstonePower() > 0) ||
        (eastBlock.type != undefined && eastBlock.getRedstonePower() > 0) ||
        (westBlock.type != undefined && westBlock.getRedstonePower() > 0) ||
        (upBlock.type != undefined && upBlock.getRedstonePower() > 0) ||
        (downBlock.type != undefined && downBlock.getRedstonePower() > 0))
    ) {
      let containerInv = containerBlock.getComponent("inventory").container
      if (
        (outputPosition == "south" && northBlock.typeId == "minecraft:air") ||
        (outputPosition == "north" && southBlock.typeId == "minecraft:air") ||
        (outputPosition == "east" && eastBlock.typeId == "minecraft:air") ||
        (outputPosition == "west" && westBlock.typeId == "minecraft:air")
      ) {
        for (let containerSlots = 0; containerSlots < containerInv.size; containerSlots++) {
          if (containerInv.getItem(containerSlots) && containerInv.getItem(containerSlots).type != undefined) {
            mc.world.getDimension("overworld").runCommandAsync(`setblock 0 -63 0 ${containerInv.getItem(containerSlots).typeId}`)
            mc.world.getDimension("overworld").runCommandAsync(`setblock 0 -63 0 air`)
            if (outputPosition == "south") {
              block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z - 1} ${containerInv.getItem(containerSlots).typeId}`);
            }
            if (outputPosition == "north") {
              block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z + 1} ${containerInv.getItem(containerSlots).typeId}`);
            }
            if (outputPosition == "east") {
              block.dimension.runCommand(`setblock ${loc.x + 1} ${loc.y} ${loc.z} ${containerInv.getItem(containerSlots).typeId}`);
            }
            if (outputPosition == "west") {
              block.dimension.runCommand(`setblock ${loc.x - 1} ${loc.y} ${loc.z} ${containerInv.getItem(containerSlots).typeId}`);
            }

            if (containerInv.getItem(containerSlots).amount == 1) {
              containerInv.setItem(containerSlots,);
            }
            if (containerInv.getItem(containerSlots).amount > 1) {
              let newItem = containerInv.getItem(containerSlots);
              newItem.amount--;
              containerInv.setItem(containerSlots, newItem);
            }
            break;
          }
        }
      }
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:block_placer ["rc:lado" = ${block.permutation.getState("rc:lado")} , "rc:on" = 1]`);
    }
  }







  if (data.id === "rc:sawyer") {
    let block = data.sourceBlock
    let outputPosition = data.message
    let loc = block.location
    let upLocation = { x: loc.x, y: loc.y + 1, z: loc.z }
    let downLocation = { x: loc.x, y: loc.y - 1, z: loc.z }
    let northLocation = { x: loc.x, y: loc.y, z: loc.z - 1 }
    let southLocation = { x: loc.x, y: loc.y, z: loc.z + 1 }
    let eastLocation = { x: loc.x + 1, y: loc.y, z: loc.z }
    let westLocation = { x: loc.x - 1, y: loc.y, z: loc.z }
    let northBlock = block.dimension.getBlock(northLocation)
    let southBlock = block.dimension.getBlock(southLocation)
    let eastBlock = block.dimension.getBlock(eastLocation)
    let westBlock = block.dimension.getBlock(westLocation)
    let upBlock = block.dimension.getBlock(upLocation)
    let downBlock = block.dimension.getBlock(downLocation)
    if (
      block.permutation.getState("rc:on") == 1 &&
      (!northBlock.getRedstonePower() > 0 || northBlock == undefined) &&
      (!southBlock.getRedstonePower() > 0 || southBlock == undefined) &&
      (!eastBlock.getRedstonePower() > 0 || eastBlock == undefined) &&
      (!westBlock.getRedstonePower() > 0 || westBlock == undefined) &&
      (!upBlock.getRedstonePower() > 0 || upBlock == undefined) &&
      (!downBlock.getRedstonePower() > 0 || downBlock == undefined)
    ) {
      block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z} ${block.typeId} [ "rc:lado"=${block.permutation.getState("rc:lado")}, "rc:on"=0]`)
    }
    if (
      block.permutation.getState("rc:on") == 0 &&
      ((northBlock.type != undefined && northBlock.getRedstonePower() > 0) ||
        (southBlock.type != undefined && southBlock.getRedstonePower() > 0) ||
        (eastBlock.type != undefined && eastBlock.getRedstonePower() > 0) ||
        (westBlock.type != undefined && westBlock.getRedstonePower() > 0) ||
        (upBlock.type != undefined && upBlock.getRedstonePower() > 0) ||
        (downBlock.type != undefined && downBlock.getRedstonePower() > 0))
    ) {
      let unbreakeBlocksVar = [
        "minecraft:acacia_log",
        "minecraft:birch_log",
        "minecraft:cherry_log",
        "minecraft:dark_oak_log",
        "minecraft:jungle_log",
        "minecraft:mangrove_log",
        "minecraft:oak_log",
        "minecraft:spruce_log"
      ]
      for (let unbreakeBlocks = 0; unbreakeBlocks < unbreakeBlocksVar.length; unbreakeBlocks++) {
        if (
          (outputPosition == "south" && northBlock != undefined && northBlock.typeId == unbreakeBlocksVar[unbreakeBlocks]) ||
          (outputPosition == "north" && southBlock != undefined && southBlock.typeId == unbreakeBlocksVar[unbreakeBlocks]) ||
          (outputPosition == "east" && eastBlock != undefined && eastBlock.typeId == unbreakeBlocksVar[unbreakeBlocks]) ||
          (outputPosition == "west" && westBlock != undefined && westBlock.typeId == unbreakeBlocksVar[unbreakeBlocks])
        ) {
          if (outputPosition == "south") {
            block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} rc:vein destroy`);
          }
          if (outputPosition == "north") {
            block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} rc:vein destroy`);
          }
          if (outputPosition == "east") {
            block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} rc:vein destroy`);
          }
          if (outputPosition == "west") {
            block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} rc:vein destroy`);
          }
          break
        }
      }
      block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z} ${block.typeId} [ "rc:lado"=${block.permutation.getState("rc:lado")}, "rc:on"=1]`)
    }
  }













  if (data.id === "rc:block_breaker") {
    let block = data.sourceBlock
    let outputPosition = data.message
    let loc = block.location
    let upLocation = { x: loc.x, y: loc.y + 1, z: loc.z }
    let downLocation = { x: loc.x, y: loc.y - 1, z: loc.z }
    let northLocation = { x: loc.x, y: loc.y, z: loc.z - 1 }
    let southLocation = { x: loc.x, y: loc.y, z: loc.z + 1 }
    let eastLocation = { x: loc.x + 1, y: loc.y, z: loc.z }
    let westLocation = { x: loc.x - 1, y: loc.y, z: loc.z }
    let northBlock = block.dimension.getBlock(northLocation)
    let southBlock = block.dimension.getBlock(southLocation)
    let eastBlock = block.dimension.getBlock(eastLocation)
    let westBlock = block.dimension.getBlock(westLocation)
    let upBlock = block.dimension.getBlock(upLocation)
    let downBlock = block.dimension.getBlock(downLocation)
    if (
      block.permutation.getState("rc:on") == 1 &&
      (!northBlock.getRedstonePower() > 0 || northBlock == undefined) &&
      (!southBlock.getRedstonePower() > 0 || southBlock == undefined) &&
      (!eastBlock.getRedstonePower() > 0 || eastBlock == undefined) &&
      (!westBlock.getRedstonePower() > 0 || westBlock == undefined) &&
      (!upBlock.getRedstonePower() > 0 || upBlock == undefined) &&
      (!downBlock.getRedstonePower() > 0 || downBlock == undefined)
    ) {
      block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z} ${block.typeId} [ "rc:lado"=${block.permutation.getState("rc:lado")}, "rc:on"=0]`)
    }
    if (
      block.permutation.getState("rc:on") == 0 &&
      ((northBlock.type != undefined && northBlock.getRedstonePower() > 0) ||
        (southBlock.type != undefined && southBlock.getRedstonePower() > 0) ||
        (eastBlock.type != undefined && eastBlock.getRedstonePower() > 0) ||
        (westBlock.type != undefined && westBlock.getRedstonePower() > 0) ||
        (upBlock.type != undefined && upBlock.getRedstonePower() > 0) ||
        (downBlock.type != undefined && downBlock.getRedstonePower() > 0))
    ) {
      let unbreakeBlocksVar = [
        "minecraft:bedrock",
        "minecraft:obsidian",
        "minecraft:lava",
        "minecraft:water",
        "minecraft:portal",
        "minecraft:end_portal_frame"
      ]
      if (
        (outputPosition == "south" && northBlock != undefined && !unbreakeBlocksVar.includes(northBlock.typeId)) ||
        (outputPosition == "north" && southBlock != undefined && !unbreakeBlocksVar.includes(southBlock.typeId)) ||
        (outputPosition == "east" && eastBlock != undefined && !unbreakeBlocksVar.includes(eastBlock.typeId)) ||
        (outputPosition == "west" && westBlock != undefined && !unbreakeBlocksVar.includes(westBlock.typeId))
      ) {
        if (outputPosition == "south") {
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} air destroy`);

        }
        if (outputPosition == "north") {
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} air destroy`);

        }
        if (outputPosition == "east") {
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} air destroy`);

        }
        if (outputPosition == "west") {
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} air destroy`);

        }
      }
      block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z} ${block.typeId} [ "rc:lado"=${block.permutation.getState("rc:lado")}, "rc:on"=1]`)
    }
  }








  if (data.id === "rc:wireless") {
    let block = data.sourceBlock;
    let color = data.message;
    let loc = block.location;
    let northLocation = { x: loc.x, y: loc.y, z: loc.z - 1 };
    let southLocation = { x: loc.x, y: loc.y, z: loc.z + 1 };
    let eastLocation = { x: loc.x + 1, y: loc.y, z: loc.z };
    let westLocation = { x: loc.x - 1, y: loc.y, z: loc.z };
    let northBlock = block.dimension.getBlock(northLocation);
    let southBlock = block.dimension.getBlock(southLocation);
    let eastBlock = block.dimension.getBlock(eastLocation);
    let westBlock = block.dimension.getBlock(westLocation);

    if (
      (northBlock.type != undefined && northBlock.getRedstonePower() > 0) ||
      (southBlock.type != undefined && southBlock.getRedstonePower() > 0) ||
      (eastBlock.type != undefined && eastBlock.getRedstonePower() > 0) ||
      (westBlock.type != undefined && westBlock.getRedstonePower() > 0)
    ) {
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:redstone_transmitter ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:color" = "${block.permutation.getState("rc:color")}", "rc:active_c" = ${block.permutation.getState("rc:active_c")}, "rc:penis" = ${block.permutation.getState("rc:penis")}, "rc:on" = 1] replace rc:redstone_transmitter ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:color" = "${block.permutation.getState("rc:color")}", "rc:active_c" = ${block.permutation.getState("rc:active_c")}, "rc:penis" = ${block.permutation.getState("rc:penis")}, "rc:on" = 0]`);
      block.dimension.runCommand(`summon rc:redstone_link ${color} ${loc.x} ${loc.y} ${loc.z}`);
    }
    if (
      (!northBlock.getRedstonePower() > 0 || northBlock == undefined) &&
      (!southBlock.getRedstonePower() > 0 || southBlock == undefined) &&
      (!eastBlock.getRedstonePower() > 0 || eastBlock == undefined) &&
      (!westBlock.getRedstonePower() > 0 || westBlock == undefined)
    ) {
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:redstone_transmitter ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:color" = "${block.permutation.getState("rc:color")}", "rc:active_c" = ${block.permutation.getState("rc:active_c")}, "rc:penis" = ${block.permutation.getState("rc:penis")}, "rc:on" = 0] replace rc:redstone_transmitter ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:color" = "${block.permutation.getState("rc:color")}", "rc:active_c" = ${block.permutation.getState("rc:active_c")}, "rc:penis" = ${block.permutation.getState("rc:penis")}, "rc:on" = 1]`);
    }
  }
  if (data.id === "rc:wireless_receiver") {
    let block = data.sourceBlock
    let loc = block.location
    block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:redstone_receiver ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:color" = "${block.permutation.getState("rc:color")}", "rc:active_c" = ${block.permutation.getState("rc:active_c")}, "rc:penis" = ${block.permutation.getState("rc:penis")}, "rc:on" = 0] replace rc:redstone_receiver ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:color" = "${block.permutation.getState("rc:color")}", "rc:active_c" = ${block.permutation.getState("rc:active_c")}, "rc:penis" = ${block.permutation.getState("rc:penis")}, "rc:on" = 1]`);

    block.dimension.runCommand(`execute as @e[type=rc:redstone_link, name=${block.permutation.getState("rc:color").replace("_dye", "")}] run fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:redstone_receiver ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:color" = "${block.permutation.getState("rc:color")}", "rc:active_c" = ${block.permutation.getState("rc:active_c")}, "rc:penis" = ${block.permutation.getState("rc:penis")}, "rc:on" = 1] replace rc:redstone_receiver ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:color" = "${block.permutation.getState("rc:color")}", "rc:active_c" = ${block.permutation.getState("rc:active_c")}, "rc:penis" = ${block.permutation.getState("rc:penis")}, "rc:on" = 0]`);
  }

  if (data.id === "rc:randomizer") {
    let block = data.sourceBlock
    let loc = block.location
    let northLocation = { x: loc.x, y: loc.y, z: loc.z - 1 }
    let southLocation = { x: loc.x, y: loc.y, z: loc.z + 1 }
    let eastLocation = { x: loc.x + 1, y: loc.y, z: loc.z }
    let westLocation = { x: loc.x - 1, y: loc.y, z: loc.z }
    let northBlock = block.dimension.getBlock(northLocation)
    let southBlock = block.dimension.getBlock(southLocation)
    let eastBlock = block.dimension.getBlock(eastLocation)
    let westBlock = block.dimension.getBlock(westLocation)
    if (
      block.permutation.getState("rc:on") == 1 &&
      (!northBlock.getRedstonePower() > 0 || northBlock == undefined) &&
      (!southBlock.getRedstonePower() > 0 || southBlock == undefined) &&
      (!eastBlock.getRedstonePower() > 0 || eastBlock == undefined) &&
      (!westBlock.getRedstonePower() > 0 || westBlock == undefined)
    ) {
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:redstone_randomizer ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:on" = 0]`);
    }
    if (
      block.permutation.getState("rc:on") == 0 &&
      ((northBlock.type != undefined && northBlock.getRedstonePower() > 0) ||
        (southBlock.type != undefined && southBlock.getRedstonePower() > 0) ||
        (eastBlock.type != undefined && eastBlock.getRedstonePower() > 0) ||
        (westBlock.type != undefined && westBlock.getRedstonePower() > 0))
    ) {
      const values = ["west", "south", "east"];
      const randomPos = Math.floor(Math.random() * values.length);
      if (randomPos == 0) {
        block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:redstone_randomizer ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:on" = ${block.permutation.getState("rc:on")}, "rc:randomized" = 1]`)
        if (block.permutation.getState("rc:lado") == 3) {
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 0] replace unpowered_repeater ["direction"= 3, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 1] replace unpowered_repeater ["direction"= 3, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 2] replace unpowered_repeater ["direction"= 3, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 3] replace unpowered_repeater ["direction"= 3, "repeater_delay"= 3]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 0] replace powered_repeater ["direction"= 3, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 1] replace powered_repeater ["direction"= 3, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 2] replace powered_repeater ["direction"= 3, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 3] replace powered_repeater ["direction"= 3, "repeater_delay"= 3]`)
        }
        if (block.permutation.getState("rc:lado") == 2) {
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 0] replace unpowered_repeater ["direction"= 1, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 1] replace unpowered_repeater ["direction"= 1, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 2] replace unpowered_repeater ["direction"= 1, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 3] replace unpowered_repeater ["direction"= 1, "repeater_delay"= 3]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 0] replace powered_repeater ["direction"= 1, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 1] replace powered_repeater ["direction"= 1, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 2] replace powered_repeater ["direction"= 1, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 3] replace powered_repeater ["direction"= 1, "repeater_delay"= 3]`)
        }
        if (block.permutation.getState("rc:lado") == 4) {
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 0] replace unpowered_repeater ["direction"= 0, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 1] replace unpowered_repeater ["direction"= 0, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 2] replace unpowered_repeater ["direction"= 0, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 3] replace unpowered_repeater ["direction"= 0, "repeater_delay"= 3]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 0] replace powered_repeater ["direction"= 0, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 1] replace powered_repeater ["direction"= 0, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 2] replace powered_repeater ["direction"= 0, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 3] replace powered_repeater ["direction"= 0, "repeater_delay"= 3]`)
        }
        if (block.permutation.getState("rc:lado") == 5) {
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 0] replace unpowered_repeater ["direction"= 2, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 1] replace unpowered_repeater ["direction"= 2, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 2] replace unpowered_repeater ["direction"= 2, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 3] replace unpowered_repeater ["direction"= 2, "repeater_delay"= 3]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 0] replace powered_repeater ["direction"= 2, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 1] replace powered_repeater ["direction"= 2, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 2] replace powered_repeater ["direction"= 2, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 3] replace powered_repeater ["direction"= 2, "repeater_delay"= 3]`)
        }
      }
      if (randomPos == 1) {
        block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:redstone_randomizer ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:on" = ${block.permutation.getState("rc:on")}, "rc:randomized" = 2]`)
        if (block.permutation.getState("rc:lado") == 3) {
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 0] replace unpowered_repeater ["direction"= 2, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 1] replace unpowered_repeater ["direction"= 2, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 2] replace unpowered_repeater ["direction"= 2, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 3] replace unpowered_repeater ["direction"= 2, "repeater_delay"= 3]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 0] replace powered_repeater ["direction"= 2, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 1] replace powered_repeater ["direction"= 2, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 2] replace powered_repeater ["direction"= 2, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 3] replace powered_repeater ["direction"= 2, "repeater_delay"= 3]`)
        }
        if (block.permutation.getState("rc:lado") == 2) {
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 0] replace unpowered_repeater ["direction"= 0, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 1] replace unpowered_repeater ["direction"= 0, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 2] replace unpowered_repeater ["direction"= 0, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 3] replace unpowered_repeater ["direction"= 0, "repeater_delay"= 3]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 0] replace powered_repeater ["direction"= 0, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 1] replace powered_repeater ["direction"= 0, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 2] replace powered_repeater ["direction"= 0, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 3] replace powered_repeater ["direction"= 0, "repeater_delay"= 3]`)
        }
        if (block.permutation.getState("rc:lado") == 4) {
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 0] replace unpowered_repeater ["direction"= 3, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 1] replace unpowered_repeater ["direction"= 3, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 2] replace unpowered_repeater ["direction"= 3, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 3] replace unpowered_repeater ["direction"= 3, "repeater_delay"= 3]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 0] replace powered_repeater ["direction"= 3, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 1] replace powered_repeater ["direction"= 3, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 2] replace powered_repeater ["direction"= 3, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 3] replace powered_repeater ["direction"= 3, "repeater_delay"= 3]`)
        }
        if (block.permutation.getState("rc:lado") == 5) {
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 0] replace unpowered_repeater ["direction"= 1, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 1] replace unpowered_repeater ["direction"= 1, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 2] replace unpowered_repeater ["direction"= 1, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 3] replace unpowered_repeater ["direction"= 1, "repeater_delay"= 3]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 0] replace powered_repeater ["direction"= 1, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 1] replace powered_repeater ["direction"= 1, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 2] replace powered_repeater ["direction"= 1, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 3] replace powered_repeater ["direction"= 1, "repeater_delay"= 3]`)
        }
      }
      if (randomPos == 2) {
        block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:redstone_randomizer ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:on" = ${block.permutation.getState("rc:on")}, "rc:randomized" = 3]`)
        if (block.permutation.getState("rc:lado") == 3) {
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 0] replace unpowered_repeater ["direction"= 1, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 1] replace unpowered_repeater ["direction"= 1, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 2] replace unpowered_repeater ["direction"= 1, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 3] replace unpowered_repeater ["direction"= 1, "repeater_delay"= 3]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 0] replace powered_repeater ["direction"= 1, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 1] replace powered_repeater ["direction"= 1, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 2] replace powered_repeater ["direction"= 1, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x + 1} ${loc.y} ${loc.z} ${loc.x + 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 1, "repeater_delay"= 3] replace powered_repeater ["direction"= 1, "repeater_delay"= 3]`)
        }
        if (block.permutation.getState("rc:lado") == 2) {
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 0] replace unpowered_repeater ["direction"= 3, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 1] replace unpowered_repeater ["direction"= 3, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 2] replace unpowered_repeater ["direction"= 3, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 3] replace unpowered_repeater ["direction"= 3, "repeater_delay"= 3]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 0] replace powered_repeater ["direction"= 3, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 1] replace powered_repeater ["direction"= 3, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 2] replace powered_repeater ["direction"= 3, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x - 1} ${loc.y} ${loc.z} ${loc.x - 1} ${loc.y} ${loc.z} powered_repeater ["direction"= 3, "repeater_delay"= 3] replace powered_repeater ["direction"= 3, "repeater_delay"= 3]`)

        }
        if (block.permutation.getState("rc:lado") == 4) {
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 0] replace unpowered_repeater ["direction"= 2, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 1] replace unpowered_repeater ["direction"= 2, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 2] replace unpowered_repeater ["direction"= 2, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 3] replace unpowered_repeater ["direction"= 2, "repeater_delay"= 3]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 0] replace powered_repeater ["direction"= 2, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 1] replace powered_repeater ["direction"= 2, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 2] replace powered_repeater ["direction"= 2, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z + 1} ${loc.x} ${loc.y} ${loc.z + 1} powered_repeater ["direction"= 2, "repeater_delay"= 3] replace powered_repeater ["direction"= 2, "repeater_delay"= 3]`)
        }
        if (block.permutation.getState("rc:lado") == 5) {
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 0] replace unpowered_repeater ["direction"= 0, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 1] replace unpowered_repeater ["direction"= 0, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 2] replace unpowered_repeater ["direction"= 0, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 3] replace unpowered_repeater ["direction"= 0, "repeater_delay"= 3]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 0] replace powered_repeater ["direction"= 0, "repeater_delay"= 0]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 1] replace powered_repeater ["direction"= 0, "repeater_delay"= 1]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 2] replace powered_repeater ["direction"= 0, "repeater_delay"= 2]`)
          block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z - 1} ${loc.x} ${loc.y} ${loc.z - 1} powered_repeater ["direction"= 0, "repeater_delay"= 3] replace powered_repeater ["direction"= 0, "repeater_delay"= 3]`)
        }
      }
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:redstone_randomizer ["rc:lado" = ${block.permutation.getState("rc:lado")},"rc:randomized" = ${block.permutation.getState("rc:randomized")}, "rc:on" = 1]`)
    }
  }




  if (data.id === "rc:ridged_plate") {
    let block = data.sourceBlock
    let loc = block.location
    let direction = data.message;
    let northLocation = { x: loc.x, y: loc.y, z: loc.z - 1 };
    let southLocation = { x: loc.x, y: loc.y, z: loc.z + 1 };
    let eastLocation = { x: loc.x + 1, y: loc.y, z: loc.z };
    let westLocation = { x: loc.x - 1, y: loc.y, z: loc.z };
    let northBlock = block.dimension.getBlock(northLocation);
    let southBlock = block.dimension.getBlock(southLocation);
    let eastBlock = block.dimension.getBlock(eastLocation);
    let westBlock = block.dimension.getBlock(westLocation);
    if (block.permutation.getState('rc:power') == 0) {
      if (direction == "ns" &&
        (northBlock.getRedstonePower() > 0 && ((northBlock != undefined && northBlock.typeId != "minecraft:powered_repeater") || (northBlock.typeId == "minecraft:powered_repeater" && northBlock.permutation.getState('direction') == 2))) ||
        (southBlock.getRedstonePower() > 0 && ((southBlock != undefined && southBlock.typeId != "minecraft:powered_repeater") || (southBlock.typeId == "minecraft:powered_repeater" && southBlock.permutation.getState('direction') == 0)))) {
        block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:ridged_plate ["rc:lado"=2, "rc:has_wire"=1, "rc:power"=15] replace rc:ridged_plate ["rc:lado"=2, "rc:has_wire"=1, "rc:power"=${block.permutation.getState("rc:power")}]`)
      }
      if (direction == "we" &&
        (westBlock.getRedstonePower() > 0 && ((westBlock != undefined && westBlock.typeId != "minecraft:powered_repeater") || (westBlock.typeId == "minecraft:powered_repeater" && westBlock.permutation.getState('direction') == 1))) ||
        (eastBlock.getRedstonePower() > 0 && ((eastBlock != undefined && eastBlock.typeId != "minecraft:powered_repeater") || (eastBlock.typeId == "minecraft:powered_repeater" && eastBlock.permutation.getState('direction') == 3)))) {
        block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:ridged_plate ["rc:lado"=4, "rc:has_wire"=1, "rc:power"=15] replace rc:ridged_plate ["rc:lado"=4, "rc:has_wire"=1, "rc:power"=${block.permutation.getState("rc:power")}]`)
      }
    }
    if (direction == "ns" &&
      (!northBlock.getRedstonePower() > 0 || northBlock == undefined) &&
      (!southBlock.getRedstonePower() > 0 || southBlock == undefined)) {
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:ridged_plate ["rc:lado"=2, "rc:has_wire"=1, "rc:power"=0] replace rc:ridged_plate ["rc:lado"=2, "rc:has_wire"=1, "rc:power"=15]`)
    }
    if (direction == "we" &&
      (!eastBlock.getRedstonePower() > 0 || eastBlock == undefined) &&
      (!westBlock.getRedstonePower() > 0 || westBlock == undefined)) {
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:ridged_plate ["rc:lado"=4, "rc:has_wire"=1, "rc:power"=0] replace rc:ridged_plate ["rc:lado"=4, "rc:has_wire"=1, "rc:power"=15]`)
    }
  }










  if (data.id === "rc:spotter") {
    let block = data.sourceBlock;
    let side = data.message;
    let loc = block.location;
    let northLocation = { x: loc.x, y: loc.y, z: loc.z - 1 };
    let southLocation = { x: loc.x, y: loc.y, z: loc.z + 1 };
    let eastLocation = { x: loc.x + 1, y: loc.y, z: loc.z };
    let westLocation = { x: loc.x - 1, y: loc.y, z: loc.z };
    let upLocation = { x: loc.x, y: loc.y + 1, z: loc.z };
    let downLocation = { x: loc.x, y: loc.y - 1, z: loc.z };
    let northBlock = block.dimension.getBlock(northLocation);
    let southBlock = block.dimension.getBlock(southLocation);
    let eastBlock = block.dimension.getBlock(eastLocation);
    let westBlock = block.dimension.getBlock(westLocation);
    let upBlock = block.dimension.getBlock(upLocation);
    let downBlock = block.dimension.getBlock(downLocation);

    if (
      (northBlock.getRedstonePower() > 0 && ((northBlock != undefined && northBlock.typeId != "minecraft:powered_repeater") || (northBlock.typeId == "minecraft:powered_repeater" && northBlock.permutation.getState('direction') == 2))) ||
      (southBlock.getRedstonePower() > 0 && ((southBlock != undefined && southBlock.typeId != "minecraft:powered_repeater") || (southBlock.typeId == "minecraft:powered_repeater" && southBlock.permutation.getState('direction') == 0))) ||
      (westBlock.getRedstonePower() > 0 && ((westBlock != undefined && westBlock.typeId != "minecraft:powered_repeater") || (westBlock.typeId == "minecraft:powered_repeater" && westBlock.permutation.getState('direction') == 1))) ||
      (eastBlock.getRedstonePower() > 0 && ((eastBlock != undefined && eastBlock.typeId != "minecraft:powered_repeater") || (eastBlock.typeId == "minecraft:powered_repeater" && eastBlock.permutation.getState('direction') == 3))) ||
      (upBlock.type != undefined && upBlock.getRedstonePower() > 0) ||
      (downBlock.type != undefined && downBlock.getRedstonePower() > 0)
    ) {
      if (side = "b") {
        block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z} run function active_vertical`);
      }
      if (side = "c") {
        block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z} run function active_vertical1`);
      }
    }
  }









  if (data.id === "rc:filtered_observer") {
    let entity = data.sourceEntity
    let loc = entity.location
    let northLocation = { x: loc.x, y: loc.y, z: loc.z - 1 }
    let southLocation = { x: loc.x, y: loc.y, z: loc.z + 1 }
    let eastLocation = { x: loc.x + 1, y: loc.y, z: loc.z }
    let westLocation = { x: loc.x - 1, y: loc.y, z: loc.z }
    let block = entity.dimension.getBlock(loc)
    let northBlock = entity.dimension.getBlock(northLocation)
    let southBlock = entity.dimension.getBlock(southLocation)
    let eastBlock = entity.dimension.getBlock(eastLocation)
    let westBlock = entity.dimension.getBlock(westLocation)
    let filter = entity.getComponent("inventory").container
    entity.runCommand(`fill ~~~~~~ rc:filtered_observer ["rc:lado" = ${block.permutation.getState('rc:lado')}, "rc:on" = 1] replace rc:filtered_observer ["rc:lado" = ${block.permutation.getState('rc:lado')}, "rc:on" = 2]`)
    for (let filterSlots = 0; filterSlots < filter.size; filterSlots++) {
      let filterItem = filter.getItem(filterSlots)
      if (filterItem != undefined) {
        if (block.permutation.getState('rc:lado') == 3 && northBlock != undefined && northBlock.typeId == filterItem.typeId) {
          entity.runCommand(`function activate_ns`)
          entity.runCommand(`fill ~~~~~~ rc:filtered_observer ["rc:lado" = ${block.permutation.getState('rc:lado')}, "rc:on" = 2] replace rc:filtered_observer ["rc:lado" = ${block.permutation.getState('rc:lado')}, "rc:on" = 1]`)
        }
        if (block.permutation.getState('rc:lado') == 2 && southBlock != undefined && southBlock.typeId == filterItem.typeId) {
          entity.runCommand(`function activate_ns`)
          entity.runCommand(`fill ~~~~~~ rc:filtered_observer ["rc:lado" = ${block.permutation.getState('rc:lado')}, "rc:on" = 2] replace rc:filtered_observer ["rc:lado" = ${block.permutation.getState('rc:lado')}, "rc:on" = 1]`)
        }
        if (block.permutation.getState('rc:lado') == 4 && eastBlock != undefined && eastBlock.typeId == filterItem.typeId) {
          entity.runCommand(`function activate_we`)
          entity.runCommand(`fill ~~~~~~ rc:filtered_observer ["rc:lado" = ${block.permutation.getState('rc:lado')}, "rc:on" = 2] replace rc:filtered_observer ["rc:lado" = ${block.permutation.getState('rc:lado')}, "rc:on" = 1]`)
        }
        if (block.permutation.getState('rc:lado') == 5 && westBlock != undefined && westBlock.typeId == filterItem.typeId) {
          entity.runCommand(`function activate_we`)
          entity.runCommand(`fill ~~~~~~ rc:filtered_observer ["rc:lado" = ${block.permutation.getState('rc:lado')}, "rc:on" = 2] replace rc:filtered_observer ["rc:lado" = ${block.permutation.getState('rc:lado')}, "rc:on" = 1]`)
        }
      }
    }
  }









  if (data.id === "rc:coil") {

    let block = data.sourceBlock
    let loc = block.location
    let northLocation = { x: loc.x, y: loc.y, z: loc.z - 1 }
    let southLocation = { x: loc.x, y: loc.y, z: loc.z + 1 }
    let eastLocation = { x: loc.x + 1, y: loc.y, z: loc.z }
    let westLocation = { x: loc.x - 1, y: loc.y, z: loc.z }
    let northBlock = block.dimension.getBlock(northLocation)
    let southBlock = block.dimension.getBlock(southLocation)
    let eastBlock = block.dimension.getBlock(eastLocation)
    let westBlock = block.dimension.getBlock(westLocation)
    if (
      block.permutation.getState("rc:power") > 0 &&
      (!northBlock.getRedstonePower() > 0 || northBlock == undefined) &&
      (!southBlock.getRedstonePower() > 0 || southBlock == undefined) &&
      (!eastBlock.getRedstonePower() > 0 || eastBlock == undefined) &&
      (!westBlock.getRedstonePower() > 0 || westBlock == undefined)
    ) {
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:electromagnetic_coil ["rc:power" = 0]`);
    }
    if (northBlock != undefined && northBlock.getRedstonePower() > 0) {
      block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z} rc:electromagnetic_coil ["rc:power" = ${northBlock.getRedstonePower()}]`)
    }
    if (southBlock != undefined && southBlock.getRedstonePower() > 0) {
      block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z} rc:electromagnetic_coil ["rc:power" = ${southBlock.getRedstonePower()}]`)
    }
    if (eastBlock != undefined && eastBlock.getRedstonePower() > 0) {
      block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z} rc:electromagnetic_coil ["rc:power" = ${eastBlock.getRedstonePower()}]`)
    }
    if (westBlock != undefined && westBlock.getRedstonePower() > 0) {
      block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z} rc:electromagnetic_coil ["rc:power" = ${westBlock.getRedstonePower()}]`)
    }
  }




  if (data.id == "rc:frequency_block") {
    const playerList = mc.world.getPlayers();
    const entity = data.sourceEntity

    if (playerList.length >= 1) {
      const form = new mcui.ActionFormData()
        .title("Wireless Frequency")
        .body("Select a frequency:")
        .button("§0Black")
        .button("§1Blue")
        .button("§nBrown")
        .button("§sCyan")
        .button("§jGray")
        .button("§2Green")
        .button("§bLight Blue")
        .button("§8Light Gray")
        .button("§aLime")
        .button("§dMagenta")
        .button("§6Orange")
        .button("§dPink")
        .button("§5Purple")
        .button("§4Red")
        .button("§fWhite")
        .button("§eYellow")

      const result = await form.show(playerList[0]);

      if (result.canceled) {
        entity.runCommand("title @s actionbar no frequency has been set");
        return -1;
      } else {
        if (result.selection == 0) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "black_dye" ]`)
        }
        if (result.selection == 1) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "blue_dye" ]`)
        }
        if (result.selection == 2) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "brown_dye" ]`)
        }
        if (result.selection == 3) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "cyan_dye" ]`)
        }
        if (result.selection == 4) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "gray_dye" ]`)
        }
        if (result.selection == 5) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "green_dye" ]`)
        }
        if (result.selection == 6) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "light_blue_dye" ]`)
        }
        if (result.selection == 7) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "light_gray_dye" ]`)
        }
        if (result.selection == 8) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "lime_dye" ]`)
        }
        if (result.selection == 9) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "magenta_dye" ]`)
        }
        if (result.selection == 10) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "orange_dye" ]`)
        }
        if (result.selection == 11) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "pink_dye" ]`)
        }
        if (result.selection == 12) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "purple_dye" ]`)
        }
        if (result.selection == 13) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "red_dye" ]`)
        }
        if (result.selection == 14) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "white_dye" ]`)
        }
        if (result.selection == 15) {
          data.sourceBlock.dimension.runCommand(`setblock ${data.sourceBlock.location.x} ${data.sourceBlock.location.y} ${data.sourceBlock.location.z} ${data.sourceBlock.typeId} [ "rc:lado"=${data.sourceBlock.permutation.getState("rc:lado")}, "rc:on"= ${data.sourceBlock.permutation.getState("rc:on")}, "rc:active_c"= ${data.sourceBlock.permutation.getState("rc:active_c")}, "rc:penis"= ${data.sourceBlock.permutation.getState("rc:penis")}, "rc:color"= "yellow_dye" ]`)
        }
      }
    }
  }



  if (data.id == "rc:frequency") {
    const playerList = mc.world.getPlayers();
    const entity = data.sourceEntity

    if (playerList.length >= 1) {
      const form = new mcui.ActionFormData()
        .title("Wireless Frequency")
        .body("Select a frequency:")
        .button("§0Black")
        .button("§1Blue")
        .button("§nBrown")
        .button("§sCyan")
        .button("§jGray")
        .button("§2Green")
        .button("§bLight Blue")
        .button("§8Light Gray")
        .button("§aLime")
        .button("§dMagenta")
        .button("§6Orange")
        .button("§dPink")
        .button("§5Purple")
        .button("§4Red")
        .button("§fWhite")
        .button("§eYellow")

      const result = await form.show(playerList[0]);

      if (result.canceled) {
        entity.runCommand("title @s actionbar no frequency has been set");
        return -1;
      } else {
        if (result.selection == 0) {
          entity.runCommand("title @s actionbar Frequency defined: §0Black")
          entity.runCommand("scoreboard players set @s frequencia 0")
        }
        if (result.selection == 1) {
          entity.runCommand("title @s actionbar Frequency defined: §1Blue")
          entity.runCommand("scoreboard players set @s frequencia 1")
        }
        if (result.selection == 2) {
          entity.runCommand("title @s actionbar Frequency defined: §nBrown")
          entity.runCommand("scoreboard players set @s frequencia 2")
        }
        if (result.selection == 3) {
          entity.runCommand("title @s actionbar Frequency defined: §sCyan")
          entity.runCommand("scoreboard players set @s frequencia 3")
        }
        if (result.selection == 4) {
          entity.runCommand("title @s actionbar Frequency defined: §2Green")
          entity.runCommand("scoreboard players set @s frequencia 4")
        }
        if (result.selection == 5) {
          entity.runCommand("title @s actionbar Frequency defined: §2Green")
          entity.runCommand("scoreboard players set @s frequencia 5")
        }
        if (result.selection == 6) {
          entity.runCommand("title @s actionbar Frequency defined: §bLight Blue")
          entity.runCommand("scoreboard players set @s frequencia 6")
        }
        if (result.selection == 7) {
          entity.runCommand("title @s actionbar Frequency defined: §8Light Gray")
          entity.runCommand("scoreboard players set @s frequencia 7")
        }
        if (result.selection == 8) {
          entity.runCommand("title @s actionbar Frequency defined: §aLime")
          entity.runCommand("scoreboard players set @s frequencia 8")
        }
        if (result.selection == 9) {
          entity.runCommand("title @s actionbar Frequency defined: §dMagenta")
          entity.runCommand("scoreboard players set @s frequencia 9")
        }
        if (result.selection == 10) {
          entity.runCommand("title @s actionbar Frequency defined: §6Orange")
          entity.runCommand("scoreboard players set @s frequencia 10")
        }
        if (result.selection == 11) {
          entity.runCommand("title @s actionbar Frequency defined: §dPink")
          entity.runCommand("scoreboard players set @s frequencia 11")
        }
        if (result.selection == 12) {
          entity.runCommand("title @s actionbar Frequency defined: §5Purple")
          entity.runCommand("scoreboard players set @s frequencia 12")
        }
        if (result.selection == 13) {
          entity.runCommand("title @s actionbar Frequency defined: §4Red")
          entity.runCommand("scoreboard players set @s frequencia 13")
        }
        if (result.selection == 14) {
          entity.runCommand("title @s actionbar Frequency defined: §fWhite")
          entity.runCommand("scoreboard players set @s frequencia 14")
        }
        if (result.selection == 15) {
          entity.runCommand("title @s actionbar Frequency defined: §eYellow")
          entity.runCommand("scoreboard players set @s frequencia 15")
        }
      }
    }
  }

  if (data.id === "rc:mobile_transmite") {
    let entity = data.sourceEntity;
    let score = mc.world.scoreboard.getObjective("frequencia").getScore(entity.scoreboardIdentity)
    if (score == 0) {
      entity.runCommandAsync(`summon rc:redstone_link black ~~~`)
    }
    if (score == 1) {
      entity.runCommandAsync(`summon rc:redstone_link blue ~~~`)
    }
    if (score == 2) {
      entity.runCommandAsync(`summon rc:redstone_link brown ~~~`)
    }
    if (score == 3) {
      entity.runCommandAsync(`summon rc:redstone_link cyan ~~~`)
    }
    if (score == 4) {
      entity.runCommandAsync(`summon rc:redstone_link gray ~~~`)
    }
    if (score == 5) {
      entity.runCommandAsync(`summon rc:redstone_link green ~~~`)
    }
    if (score == 6) {
      entity.runCommandAsync(`summon rc:redstone_link light_blue ~~~`)
    }
    if (score == 7) {
      entity.runCommandAsync(`summon rc:redstone_link light_gray ~~~`)
    }
    if (score == 8) {
      entity.runCommandAsync(`summon rc:redstone_link lime ~~~`)
    }
    if (score == 9) {
      entity.runCommandAsync(`summon rc:redstone_link magenta ~~~`)
    }
    if (score == 10) {
      entity.runCommandAsync(`summon rc:redstone_link orange ~~~`)
    }
    if (score == 11) {
      entity.runCommandAsync(`summon rc:redstone_link pink ~~~`)
    }
    if (score == 12) {
      entity.runCommandAsync(`summon rc:redstone_link purple ~~~`)
    }
    if (score == 13) {
      entity.runCommandAsync(`summon rc:redstone_link red ~~~`)
    }
    if (score == 14) {
      entity.runCommandAsync(`summon rc:redstone_link white ~~~`)
    }
    if (score == 15) {
      entity.runCommandAsync(`summon rc:redstone_link yellow ~~~`)
    }
  }









  if (data.id === "rc:cross") {
    let block = data.sourceBlock
    let loc = block.location
    let northLocation = { x: loc.x, y: loc.y, z: loc.z - 1 }
    let southLocation = { x: loc.x, y: loc.y, z: loc.z + 1 }
    let eastLocation = { x: loc.x + 1, y: loc.y, z: loc.z }
    let westLocation = { x: loc.x - 1, y: loc.y, z: loc.z }
    let northBlock = block.dimension.getBlock(northLocation)
    let southBlock = block.dimension.getBlock(southLocation)
    let eastBlock = block.dimension.getBlock(eastLocation)
    let westBlock = block.dimension.getBlock(westLocation)
    if (
      (northBlock.getRedstonePower() > 0 && ((northBlock != undefined && northBlock.typeId != "minecraft:powered_repeater") || (northBlock.typeId == "minecraft:powered_repeater" && northBlock.permutation.getState('direction') == 2))) ||
      (southBlock.getRedstonePower() > 0 && ((southBlock != undefined && southBlock.typeId != "minecraft:powered_repeater") || (southBlock.typeId == "minecraft:powered_repeater" && southBlock.permutation.getState('direction') == 0))) &&
      !(westBlock.getRedstonePower() > 0 && ((westBlock != undefined && westBlock.typeId != "minecraft:powered_repeater") || (westBlock.typeId == "minecraft:powered_repeater" && westBlock.permutation.getState('direction') == 1))) &&
      !(eastBlock.getRedstonePower() > 0 && ((eastBlock != undefined && eastBlock.typeId != "minecraft:powered_repeater") || (eastBlock.typeId == "minecraft:powered_repeater" && eastBlock.permutation.getState('direction') == 3)))
    ) {
      block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z} run function activate_ns`)
      block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z} run function desactivate_we`)
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:redstone_cross ["rc:on"=1]`)
    }
    if (
      (westBlock.getRedstonePower() > 0 && ((westBlock != undefined && westBlock.typeId != "minecraft:powered_repeater") || (westBlock.typeId == "minecraft:powered_repeater" && westBlock.permutation.getState('direction') == 1))) ||
      (eastBlock.getRedstonePower() > 0 && ((eastBlock != undefined && eastBlock.typeId != "minecraft:powered_repeater") || (eastBlock.typeId == "minecraft:powered_repeater" && eastBlock.permutation.getState('direction') == 3))) &&
      !(northBlock.getRedstonePower() > 0 && ((northBlock != undefined && northBlock.typeId != "minecraft:powered_repeater") || (northBlock.typeId == "minecraft:powered_repeater" && northBlock.permutation.getState('direction') == 2))) &&
      !(southBlock.getRedstonePower() > 0 && ((southBlock != undefined && southBlock.typeId != "minecraft:powered_repeater") || (southBlock.typeId == "minecraft:powered_repeater" && southBlock.permutation.getState('direction') == 0)))
    ) {
      block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z} run function activate_we`)
      block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z} run function desactivate_ns`)
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:redstone_cross ["rc:on"=2]`)
    }
    if (
      ((northBlock.getRedstonePower() > 0 && ((northBlock != undefined && northBlock.typeId != "minecraft:powered_repeater") || (northBlock.typeId == "minecraft:powered_repeater" && northBlock.permutation.getState('direction') == 2))) ||
        (southBlock.getRedstonePower() > 0 && ((southBlock != undefined && southBlock.typeId != "minecraft:powered_repeater") || (southBlock.typeId == "minecraft:powered_repeater" && southBlock.permutation.getState('direction') == 0)))) &&
      ((westBlock.getRedstonePower() > 0 && ((westBlock != undefined && westBlock.typeId != "minecraft:powered_repeater") || (westBlock.typeId == "minecraft:powered_repeater" && westBlock.permutation.getState('direction') == 1))) ||
        (eastBlock.getRedstonePower() > 0 && ((eastBlock != undefined && eastBlock.typeId != "minecraft:powered_repeater") || (eastBlock.typeId == "minecraft:powered_repeater" && eastBlock.permutation.getState('direction') == 3))))
    ) {
      block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z} run function redstone_link`)
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:redstone_cross ["rc:on"=3]`)
    }
    if (
      !(northBlock.getRedstonePower() > 0 && ((northBlock != undefined && northBlock.typeId != "minecraft:powered_repeater") || (northBlock.typeId == "minecraft:powered_repeater" && northBlock.permutation.getState('direction') == 2))) &&
      !(southBlock.getRedstonePower() > 0 && ((southBlock != undefined && southBlock.typeId != "minecraft:powered_repeater") || (southBlock.typeId == "minecraft:powered_repeater" && southBlock.permutation.getState('direction') == 0))) &&
      !(westBlock.getRedstonePower() > 0 && ((westBlock != undefined && westBlock.typeId != "minecraft:powered_repeater") || (westBlock.typeId == "minecraft:powered_repeater" && westBlock.permutation.getState('direction') == 1))) &&
      !(eastBlock.getRedstonePower() > 0 && ((eastBlock != undefined && eastBlock.typeId != "minecraft:powered_repeater") || (eastBlock.typeId == "minecraft:powered_repeater" && eastBlock.permutation.getState('direction') == 3)))
    ) {
      block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z} run function desactivate_we`)
      block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z} run function desactivate_ns`)
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} rc:redstone_cross ["rc:on"=0]`)
    }
  }







  if (data.id === "rc:fan") {
    let block = data.sourceBlock
    let outputPosition = data.message
    let loc = block.location
    let upLocation = { x: loc.x, y: loc.y + 1, z: loc.z }
    let downLocation = { x: loc.x, y: loc.y - 1, z: loc.z }
    let northLocation = { x: loc.x, y: loc.y, z: loc.z - 1 }
    let southLocation = { x: loc.x, y: loc.y, z: loc.z + 1 }
    let eastLocation = { x: loc.x + 1, y: loc.y, z: loc.z }
    let westLocation = { x: loc.x - 1, y: loc.y, z: loc.z }
    let northBlock = block.dimension.getBlock(northLocation)
    let southBlock = block.dimension.getBlock(southLocation)
    let eastBlock = block.dimension.getBlock(eastLocation)
    let westBlock = block.dimension.getBlock(westLocation)
    let upBlock = block.dimension.getBlock(upLocation)
    let downBlock = block.dimension.getBlock(downLocation)
    if (
      block.permutation.getState("rc:on") == 1 &&
      (!northBlock.getRedstonePower() > 0 || northBlock == undefined) &&
      (!southBlock.getRedstonePower() > 0 || southBlock == undefined) &&
      (!eastBlock.getRedstonePower() > 0 || eastBlock == undefined) &&
      (!westBlock.getRedstonePower() > 0 || westBlock == undefined) &&
      (!upBlock.getRedstonePower() > 0 || upBlock == undefined) &&
      (!downBlock.getRedstonePower() > 0 || downBlock == undefined)
    ) {
      block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z} ${block.typeId} [ "rc:lado"=${block.permutation.getState("rc:lado")}, "rc:on"=0]`)
    }
    if (
      ((northBlock.type != undefined && northBlock.getRedstonePower() > 0) ||
        (southBlock.type != undefined && southBlock.getRedstonePower() > 0) ||
        (eastBlock.type != undefined && eastBlock.getRedstonePower() > 0) ||
        (westBlock.type != undefined && westBlock.getRedstonePower() > 0) ||
        (upBlock.type != undefined && upBlock.getRedstonePower() > 0) ||
        (downBlock.type != undefined && downBlock.getRedstonePower() > 0))
    ) {
      if (outputPosition == "up") {
        block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y + 6} ${loc.z} as @e[type=item,r=6] at @s run tp @s ~~0.1~`)
        block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y + 3} ${loc.z} as @e[type=item,r=3] at @s run tp @s ~~0.2~`)
      }
      if (outputPosition == "south") {
        block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z - 6} as @e[type=item,r=6] at @s run tp @s ~~~-0.1`)
        block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z - 3} as @e[type=item,r=3] at @s run tp @s ~~~-0.2`)
      }
      if (outputPosition == "north") {
        block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z + 6} as @e[type=item,r=6] at @s run tp @s ~~~0.1`)
        block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z + 3} as @e[type=item,r=3] at @s run tp @s ~~~0.2`)
      }
      if (outputPosition == "east") {
        block.dimension.runCommand(`execute positioned ${loc.x + 6} ${loc.y} ${loc.z} as @e[type=item,r=6] at @s run tp @s ~0.1~~`)
        block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y} ${loc.z + 3} as @e[type=item,r=3] at @s run tp @s ~~~0.2`)
      }
      if (outputPosition == "west") {
        block.dimension.runCommand(`execute positioned ${loc.x - 6} ${loc.y} ${loc.z} as @e[type=item,r=6] at @s run tp @s ~-0.1~~`)
        block.dimension.runCommand(`execute positioned ${loc.x - 3} ${loc.y} ${loc.z} as @e[type=item,r=3] at @s run tp @s ~-0.2~~`)
      }
      block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z} ${block.typeId} [ "rc:lado"=${block.permutation.getState("rc:lado")}, "rc:on"=1]`)
    }
  }















  if (data.id === "rc:toggle") {
    let block = data.sourceBlock
    let loc = block.location
    let stage = data.message
    let northLocation = { x: loc.x, y: loc.y, z: loc.z - 1 }
    let southLocation = { x: loc.x, y: loc.y, z: loc.z + 1 }
    let eastLocation = { x: loc.x + 1, y: loc.y, z: loc.z }
    let westLocation = { x: loc.x - 1, y: loc.y, z: loc.z }
    let northBlock = block.dimension.getBlock(northLocation)
    let southBlock = block.dimension.getBlock(southLocation)
    let eastBlock = block.dimension.getBlock(eastLocation)
    let westBlock = block.dimension.getBlock(westLocation)
    if (
      stage == "um" &&
      ((northBlock.getRedstonePower() > 0 && ((northBlock != undefined && northBlock.typeId != "minecraft:powered_repeater") || (northBlock.typeId == "minecraft:powered_repeater" && northBlock.permutation.getState('direction') == 2))) ||
        (southBlock.getRedstonePower() > 0 && ((southBlock != undefined && southBlock.typeId != "minecraft:powered_repeater") || (southBlock.typeId == "minecraft:powered_repeater" && southBlock.permutation.getState('direction') == 0))) ||
        (westBlock.getRedstonePower() > 0 && ((westBlock != undefined && westBlock.typeId != "minecraft:powered_repeater") || (westBlock.typeId == "minecraft:powered_repeater" && westBlock.permutation.getState('direction') == 1))) ||
        (eastBlock.getRedstonePower() > 0 && ((eastBlock != undefined && eastBlock.typeId != "minecraft:powered_repeater") || (eastBlock.typeId == "minecraft:powered_repeater" && eastBlock.permutation.getState('direction') == 3))))) {
      block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z} ${block.typeId} [ "rc:lado"=${block.permutation.getState("rc:lado")}, "rc:on"=1]`)
    }
    if (
      stage == "dois" &&
      ((!northBlock.getRedstonePower() > 0 || northBlock == undefined) &&
        (!southBlock.getRedstonePower() > 0 || southBlock == undefined) &&
        (!eastBlock.getRedstonePower() > 0 || eastBlock == undefined) &&
        (!westBlock.getRedstonePower() > 0 || westBlock == undefined))) {
      block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z} ${block.typeId} [ "rc:lado"=${block.permutation.getState("rc:lado")}, "rc:on"=2]`)
    }
    if (
      stage == "tres" &&
      ((northBlock.getRedstonePower() > 0 && ((northBlock != undefined && northBlock.typeId != "minecraft:powered_repeater") || (northBlock.typeId == "minecraft:powered_repeater" && northBlock.permutation.getState('direction') == 2))) ||
        (southBlock.getRedstonePower() > 0 && ((southBlock != undefined && southBlock.typeId != "minecraft:powered_repeater") || (southBlock.typeId == "minecraft:powered_repeater" && southBlock.permutation.getState('direction') == 0))) ||
        (westBlock.getRedstonePower() > 0 && ((westBlock != undefined && westBlock.typeId != "minecraft:powered_repeater") || (westBlock.typeId == "minecraft:powered_repeater" && westBlock.permutation.getState('direction') == 1))) ||
        (eastBlock.getRedstonePower() > 0 && ((eastBlock != undefined && eastBlock.typeId != "minecraft:powered_repeater") || (eastBlock.typeId == "minecraft:powered_repeater" && eastBlock.permutation.getState('direction') == 3))))) {
      block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z} ${block.typeId} [ "rc:lado"=${block.permutation.getState("rc:lado")}, "rc:on"=3]`)
    }
    if (
      stage == "quatro" &&
      ((!northBlock.getRedstonePower() > 0 || northBlock == undefined) &&
        (!southBlock.getRedstonePower() > 0 || southBlock == undefined) &&
        (!eastBlock.getRedstonePower() > 0 || eastBlock == undefined) &&
        (!westBlock.getRedstonePower() > 0 || westBlock == undefined))) {
      block.dimension.runCommand(`setblock ${loc.x} ${loc.y} ${loc.z} ${block.typeId} [ "rc:lado"=${block.permutation.getState("rc:lado")}, "rc:on"=0]`)
    }
  }




  if (data.id === "rc:wireless_lamp") {
    let block = data.sourceBlock
    let loc = block.location
    block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} ${block.typeId} ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:color" = "${block.permutation.getState("rc:color")}", "rc:active_c" = ${block.permutation.getState("rc:active_c")}, "rc:penis" = ${block.permutation.getState("rc:penis")}, "rc:on" = 0]`);

    block.dimension.runCommand(`execute as @e[type=rc:redstone_link, name=${block.permutation.getState("rc:color").replace("_dye", "")}] run fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} ${block.typeId} ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:color" = "${block.permutation.getState("rc:color")}", "rc:active_c" = ${block.permutation.getState("rc:active_c")}, "rc:penis" = ${block.permutation.getState("rc:penis")}, "rc:on" = 1]`);
  }

  if (data.id === "rc:wireless_lamp_top") {
    let block = data.sourceBlock
    let loc = block.location
    let upLocation = { x: loc.x, y: loc.y + 1, z: loc.z }
    let upBlock = block.dimension.getBlock(upLocation)
    if (upBlock.isSolid()) {
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} ${block.typeId} ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:color" = "${block.permutation.getState("rc:color")}", "rc:active_c" = ${block.permutation.getState("rc:active_c")}, "rc:penis" = ${block.permutation.getState("rc:penis")}, "rc:on" = ${block.permutation.getState("rc:on")}, "rc:top" = 1]`)
    }

    if (upBlock.isAir()) {
      block.dimension.runCommand(`fill ${loc.x} ${loc.y} ${loc.z} ${loc.x} ${loc.y} ${loc.z} ${block.typeId} ["rc:lado" = ${block.permutation.getState("rc:lado")}, "rc:color" = "${block.permutation.getState("rc:color")}", "rc:active_c" = ${block.permutation.getState("rc:active_c")}, "rc:penis" = ${block.permutation.getState("rc:penis")}, "rc:on" = ${block.permutation.getState("rc:on")}, "rc:top" = 0]`)
    }
  }





  if (data.id === "rc:precision_hopper") {





    let entity = data.sourceEntity
    let loc = entity.location
    let upLocation = { x: loc.x, y: loc.y + 1, z: loc.z }
    let blockup = entity.dimension.getBlock(upLocation)
    let downLocation = { x: loc.x, y: loc.y - 1, z: loc.z }
    let blockdown = entity.dimension.getBlock(downLocation)
    let chestUpperInv = blockup.getComponent("inventory").container
    let filter = entity.getComponent("inventory").container
    let chestDownInv = blockdown.getComponent("inventory").container

    let northLocation = { x: loc.x, y: loc.y, z: loc.z - 1 }
    let southLocation = { x: loc.x, y: loc.y, z: loc.z + 1 }
    let eastLocation = { x: loc.x + 1, y: loc.y, z: loc.z }
    let westLocation = { x: loc.x - 1, y: loc.y, z: loc.z }
    let northBlock = entity.dimension.getBlock(northLocation)
    let southBlock = entity.dimension.getBlock(southLocation)
    let eastBlock = entity.dimension.getBlock(eastLocation)
    let westBlock = entity.dimension.getBlock(westLocation)

    if (
      (!northBlock.getRedstonePower() > 0 || northBlock == undefined) &&
      (!southBlock.getRedstonePower() > 0 || southBlock == undefined) &&
      (!eastBlock.getRedstonePower() > 0 || eastBlock == undefined) &&
      (!westBlock.getRedstonePower() > 0 || westBlock == undefined)
    ) {
      for (let containerUpperSlots = 0; containerUpperSlots < chestUpperInv.size; containerUpperSlots++) {
        let chestUpItem = chestUpperInv.getItem(containerUpperSlots)
        for (let filterSlots = 0; filterSlots < filter.size; filterSlots++) {
          let filterItem = filter.getItem(filterSlots)
          if (chestUpItem != undefined && filterItem != undefined) {
            if (chestUpItem.type == filterItem.type
            ) {
              for (let containerSlots = 0; containerSlots < chestDownInv.size; containerSlots++) {
                if (!chestDownInv.getItem(containerSlots) || (chestDownInv.getItem(containerSlots).typeId == chestUpperInv.getItem(containerUpperSlots).typeId && chestDownInv.getItem(containerSlots).amount < 64)) {
                  let newItem = chestUpperInv.getItem(containerUpperSlots);
                  newItem.amount = 1
                  chestDownInv.addItem(newItem)
                  if (chestUpperInv.getItem(containerUpperSlots).amount == 1) {
                    chestUpperInv.setItem(containerUpperSlots,);
                  }
                  if (chestUpperInv.getItem(containerUpperSlots).amount > 1) {
                    let newItem = chestUpperInv.getItem(containerUpperSlots);
                    newItem.amount--;
                    chestUpperInv.setItem(containerUpperSlots, newItem);
                  }
                  break;
                }
              }
            }
          }
        }
      }
    }
  }



  if (data.id === "rc:leaky_hopper") {
    let block = data.sourceBlock
    let loc = block.location
    let upLocation = { x: loc.x, y: loc.y + 1, z: loc.z }
    let spawnLocation = { x: loc.x, y: loc.y - 0.5, z: loc.z }
    let nspawnLocation = { x: loc.x + 0.5, y: loc.y - 1, z: loc.z + 0.5 }
    let containerBlock = block.dimension.getBlock(upLocation)

    let entity = block.dimension.getEntitiesAtBlockLocation({ x: loc.x, y: loc.y + 1, z: loc.z })
    entity.forEach(ent => {
      ent.tryTeleport(nspawnLocation)
    })
    let containerInv = containerBlock.getComponent("inventory").container
    for (let containerSlots = 0; containerSlots < containerInv.size; containerSlots++) {
      if (containerInv.getItem(containerSlots) && containerInv.getItem(containerSlots).type != undefined) {
        let dropItem = containerInv.getItem(containerSlots)
        dropItem.amount = 1
        block.dimension.spawnItem(dropItem, spawnLocation)
        block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y - 1} ${loc.z} run tp @e[type=item,r=1,tag=!teleported_yet] ${loc.x} ${loc.y - 0.3} ${loc.z}`)
        block.dimension.runCommand(`execute positioned ${loc.x} ${loc.y - 1} ${loc.z} run tag @e[type=item,r=1,tag=!teleported_yet] add teleported_yet`)
        if (containerInv.getItem(containerSlots).amount == 1) {
          containerInv.setItem(containerSlots,);
        }
        if (containerInv.getItem(containerSlots).amount > 1) {
          let newItem = containerInv.getItem(containerSlots);
          newItem.amount--;
          containerInv.setItem(containerSlots, newItem);
        }
        break;
      }
    }
  }


  if (data.id === "rc:item_elevator") {
    let block = data.sourceBlock
    let loc = block.location
    let entity = block.dimension.getEntities({
      type: "minecraft:item",
      location: loc,
      maxDistance: 2,
      minDistance: 0
    });
    let upLocation = { x: loc.x, y: loc.y - 1, z: loc.z }
    let spawnLocation = { x: loc.x + 0.5, y: loc.y + 1, z: loc.z + 0.5 }
    let containerBlock = block.dimension.getBlock(upLocation)
    entity.forEach(ent => {
      ent.tryTeleport(spawnLocation)
    })
    let containerInv = containerBlock.getComponent("inventory").container
    for (let containerSlots = 0; containerSlots < containerInv.size; containerSlots++) {
      if (containerInv.getItem(containerSlots) && containerInv.getItem(containerSlots).type != undefined) {
        let dropItem = containerInv.getItem(containerSlots)
        dropItem.amount = 1
        block.dimension.spawnItem(dropItem, spawnLocation)
        if (containerInv.getItem(containerSlots).amount == 1) {
          containerInv.setItem(containerSlots,);
        }
        if (containerInv.getItem(containerSlots).amount > 1) {
          let newItem = containerInv.getItem(containerSlots);
          newItem.amount--;
          containerInv.setItem(containerSlots, newItem);
        }
        break;
      }
    }
  }
}
)
