import {ItemTypes, world, ItemStack, system} from '@minecraft/server';

let playerSortCooldown = [];
let playerSort = [];

world.beforeEvents.itemUse.subscribe((eventData)=>{
        const player = eventData.source;
        const inv = player.getComponent("inventory").container;
        const item = inv.getItem(player.selectedSlot);
        if(item.typeId !== "sorter:inv_sorter"){
                return;
        }
	//eventData.source.runCommandAsync(`say test`);
	let playerName = eventData.source.name;
	if(!playerSortCooldown.hasOwnProperty(playerName)){
		playerSortCooldown[playerName] = [];
		playerSortCooldown[playerName].push(eventData.source);
		playerSortCooldown[playerName].push(20);
		playerSortCooldown[playerName].push(false);
	}else if(playerSortCooldown[playerName][1]<=0 && playerSortCooldown[playerName][2]){
		playerSortCooldown[playerName][1] = 20
		playerSortCooldown[playerName][2] = false;
	}	
});

system.runInterval(()=>{
	for(let playerName in playerSortCooldown){
		//world.getDimension('overworld').runCommandAsync(`say ${playerName}`);
		let player = playerSortCooldown[playerName][0];
		let cooldownCount = playerSortCooldown[playerName][1];
		let cooldown = playerSortCooldown[playerName][2];
		if(cooldownCount==20 && !cooldown){
			sortInventory(player);
			playerSortCooldown[playerName][1]--;
			playerSortCooldown[playerName][2] = true;
		}else if(cooldownCount>0){			
			playerSortCooldown[playerName][1]--;	
		}
	}
},1);

async function sortInventory(player){	
	let entity = player;	
	let itemArray = [];
		let container = entity.getComponent('inventory').container;
		//get all items except for hotbar items
		for(let slot=0; slot<container.size; slot++){
			if((slot<=8 && !container.getItem(slot))){
				container.setItem(slot,new ItemStack(ItemTypes.get('Minecraft:barrier'),1));
				continue;
			}else if( slot<=8 || !container.getItem(slot)){
				continue;	
			}else{
				itemArray.push(container.getItem(slot));
				container.setItem(slot,undefined);
			}
		}
		//sort items
		let promise = new Promise((resolve)=>{
		try{
		itemArray.sort((a, b) => {
		let first;
		let second;
		
		if(a.nameTag){
			first = a.nameTag;
		}else{
			first = a.typeId.split(':')[1];
		}
		
		if(b.nameTag){
			second = b.nameTag;
		}else{
			second = b.typeId.split(':')[1];
		}
		
		if(first > second){
			return 1;
		}else if(first == second){
			return 1;
		}else{
			return -1;
		}	
		});	
		for(let item of itemArray){
			container.addItem(item);
		}
		entity.onScreenDisplay.setActionBar(`§6Inventory Sorted!`);
		entity.runCommandAsync(`clear @s barrier`);
		resolve();	
		}catch(e){
		console.warn(`${e}`);	
		}
		});
		await promise;
}