import {system,ItemTypes, world,ItemStack,MinecraftBlockTypes} from '@minecraft/server';
    
const beforeItemUse = world.beforeEvents.itemUseOn;

let cooldownPlayer = [];

let blockRayCast = {includeLiquidBlocks:true,includePassableBlocks:false,maxDistance:9};
beforeItemUse.subscribe(bItemUse);  

system.beforeEvents.watchdogTerminate.subscribe((eventData)=>{
	eventData.cancel=true;
});

function bItemUse(eventData){
let player = eventData.source;
if(eventData.itemStack.typeId != "sorter:sorting_wand") return;
for(let cooldown of cooldownPlayer){
	if(player.name == cooldown.name){
		return
	}
}
if(!player.isSneaking) return;
	
	let block = player.getBlockFromViewDirection(blockRayCast);		
	system.run(()=>{
		if(!block) return
		if ((!(isContainer(block.block.typeId)))) {
			player.onScreenDisplay.setActionBar(`§4Can only be used on a chest!`);
			return;
		}
		cooldownPlayer.push({"name":`${player.name}`,"cooldown":10});
		for(let cooldown of cooldownPlayer){
			if(cooldown.name == player.name){
				system.run(function ticking(){
					player.onScreenDisplay.setActionBar(`    §6Chest Sorted!\n§cSort In Cooldown: ${cooldown.cooldown}`);				
					if(cooldown.cooldown <= 0){
						sort(player,block.block);
						player.onScreenDisplay.setActionBar(`§eCooldown Done`);									
					}else{
						system.run(ticking);	
					}
				});
			}
		}		
	})		
}

system.runInterval(function cooldown(){
	let index = 0;
	for(let cooldown of cooldownPlayer){
		if(cooldown.cooldown <= 0){
			cooldownPlayer.splice(index,1);
			return;
		}
		cooldown.cooldown--;
		index++;
	}
},1);

function sort(entityData,block){		
	let blockPos = block.location;
	let itemsObj = [];
	
	if(!block) return;
	
	var inv;
	try{
	inv = block.getComponent("inventory").container;
	}catch(e){
		entityData.onScreenDisplay.setActionBar(`§4Failed to get block inventory!`);	
	}
	/*
	if(inv.size>=28){
		entityData.runCommandAsync(`title @s actionbar §4You Can't Sort a Double Chest!`);
		return;
	}	*/	
	
	for(let c = 0; c<inv.size; c++){							
		let item = inv.getItem(c);
		if(!item) continue;
		itemsObj.push(item);
		inv.setItem(c,null);
		//entityData.runCommandAsync(`replaceitem block ${blockPos.x} ${blockPos.y} ${blockPos.z} slot.container ${c} air 1 0`);	
		//inv.setItem(c,new ItemStack(MinecraftItemTypes.air,1,0));			
	}

	try{
	entityData.onScreenDisplay.setActionBar(`§6Chest Sorted!`);
	itemsObj.sort((a, b) => {
		let first;
		let second;
		
		if(a.nameTag){
			first = a.nameTag;
		}else{
			first = a.typeId.split(':')[1];
		}
		
		if(b.nameTag){
			second = b.nameTag;
		}else{
			second = b.typeId.split(':')[1];
		}
		
		if(first > second){
			return 1;
		}else if(first == second){
			return 1;
		}else{
			return -1;
		}	
	});	
	
	//itemsObj.sort((a, b) => ((a.typeId.split(':'))[1] > ((b.typeId.split(':'))[1])) ? 1: ((a.typeId.split(':'))[1] == ((b.typeId.split(':'))[1])) ? 1 : -1);	
	for(let item of itemsObj){
		inv.addItem(item);
	}
	}catch(e){
		entityData.runCommandAsync(`tell @s §4Error Sorting! - ${e}`);	
	}
}	

function writeItem(){
	
}

function isContainer(blockName){
//Having problem getting container of barrel and shulker box

	try{
		if(blockName == MinecraftBlockTypes.chest.id){
			return true;
		}
		if(blockName == MinecraftBlockTypes.barrel.id){
			return true;
		}
		if(blockName == MinecraftBlockTypes.shulkerBox.id){
			return true;
		}
		if(blockName == MinecraftBlockTypes.undyedShulkerBox.id){
			return true;
		}
		if(blockName == MinecraftBlockTypes.dropper.id){
			return true;
		}
		if(blockName == MinecraftBlockTypes.dispenser.id){
			return true;
		}
	return false;
	}catch(e){
		console.warn(`${e}`);	
	}
}

function upCase(itemName){
	let strArr = itemName.split('_');
	for(var c in strArr){
		if(c != 0){
		strArr[c] = strArr[c].charAt(0).toUpperCase() + strArr[c].slice(1);
		//Commands.run(`say ${strArr.join('')}`, world.getDimension("overworld"));		
		}
	}
	let strItem = (strArr.join('')).split(':');
	return strItem[1];
}
